declare filename "BLIT_saw.dsp"; declare name "BLIT_saw"; ba = library("basics.lib");
ma = library("maths.lib");
fi = library("filters.lib");

// Nyquist
ny = ma.SR/2;

// angular frequency
w(x) = x*2*ma.PI/ma.SR;

// differentiator
diff(x) = x-x';

// NAN-safe divider
div(x1, x2) = ba.if(x2 : ==(0), 0, (x1, x2 : /));

// phasor with phase reset
ph(freq, reset) = freq/ma.SR : (+ : ma.decimal) ~ *(1-(reset : !=(0)));

// 1-pole lowpass; for stability, CF should be between 0 and Ny 
// (design by Chamberlin)
lp1p(cf, in) = in*a0 : + 
                       ~ *(b1)
with {
      a0 = 1-(b1);
      b1 = exp(w(cf)*(-1));
};

// unipolar BLIT
blit_up(f, h) = ba.if(phase : ==(0), 1, sinc)
with {
      sinc =   sin(phase*h_1), sin(phase) : div, h_1 : div;
      phase = ph(f_1, 0)*2*ma.PI;
      f_1 = f/2;
      h_1 = diff(phase) : <(0),
            (h*2+1 : min(lim) : int) : ba.sAndH;
      lim = ba.if((int((ma.SR, f : div)) : %(2) : ==(0)), int((ma.SR, f : div))-1, int((ma.SR, f : div)));
};


saw(f, h) = blit_up(f, h) <:   _,
                               lp1p(f/100) : - : fi.pole(1-10/ma.SR) : *(scale)
with {
      lim =    ny,
               f : div;
      scale =  (h : min(lim)), 
               lim : div;
};

f = hslider("freq", 135, 0.0001, 10000, 0.0001);
h = hslider("h", 5, 0.5, 100, 0.001);

process = saw(f, h) : _;