declare filename "blit_bp.dsp"; declare name "blit_bp"; ba = library("basics.lib");
ma = library("maths.lib");
//m2 = library("maths2.lib");

// differentiator
diff(x) = x-x';

// phasor with phase reset
ph(freq, reset) = freq/ma.SR : (+ : ma.decimal) ~ *(1-(reset : !=(0)));

// first derivative
delta(s, t, in) = in, d2.del_lin(s, t, in) : -;

// NAN-safe divider
div(x1, x2) = ba.if(x2 : ==(0), 0, (x1, x2 : /));

// bipolar BLIT
blit_bp(f, h, d) = delta(10, d1, blit_up(f, h))
with {
      d1 = d*( 1, f : div);
};

// unipolar BLIT
blit_up(f, h) = ba.if(phase : ==(0), 1, sinc)
with {
      sinc =   sin(phase*h_1),
               sin(phase) : div, 
                            h_1 : div;
      phase = ph(f_1, 0)*2*ma.PI;
      f_1 = f/2;
      h_1 = diff(phase) : <(0),
            (h*2+1 : min(lim) : int) : ba.sAndH;
      lim = ba.if((int((ma.SR,
                       f : div)) : %(2) : ==(0)), 
                   int((ma.SR,
                       f : div))-1, 
                   int((ma.SR,
                       f : div)));
};

f = hslider("freq", 435, 0.0001, 10000, 0.0001);
h = hslider("h", 1.3, 0.5, 100, 0.001);

process = blit_up(f, h) : _;