declare filename "rms_dynamical_normalisation.dsp"; declare name "rms_dynamical_normalisation"; // dynamical compression based on RMS

ma = library("maths.lib");
ba = library("basics.lib");
si = library ("signals.lib");

// NAN-safe divider
div(x1, x2) = ba.if(x2 : ==(0), 0, (x1 , x2 : /));

// angular frequency
w(x) = x*2*ma.PI/ma.SR;

// 1-pole lowpass; for stability, CF should be between 0 and Ny 
// (design by Chamberlin)
lp1p(cf, in) = in*a0 : + ~ *(b1)
with {
        a0 = 1-(b1);
        b1 = exp(w(cf)*(-1));
};

// root mean square measurement using lowpass
rms(window, in) = in <: * : lp1p(window) : sqrt;

// dynamical normalisation based on RMS
dyn_norm_rms(window, target, input) = input*ratio
with {
      ratio =  rms(window, target), rms(window, input) : div;
};

target = hslider("target", 1.0, 0.00001, 10000.0, 0.00001):si.smoo;
window = hslider("window", 1.0, 0.00001, 10000.0, 0.00001)/1000;

process = _ : dyn_norm_rms(window, target) : _ ;